//==========================
//
//  KeyIn Far Plugin/002
//
//  copyleft 2k-46 Stager

library keyin;

uses
  Windows, SysUtils,
  FARIntf in 'FARIntf.pas',
  Langs in 'Langs.pas';

const
  iKeys=105;
var
  ssPlugins: array [0..0] of PChar;
type
  TbsKeys = array [1..iKeys] of integer;
  TssKeys = array [1..iKeys] of string[11];
const
  sPrefix:Pchar='kbrd';
  bsKeys:TbsKeys=(
// numpad
    96,97,98,99,100,101,102,103,104,105,111,106,109,107,110,
// control
    8,32, 27, 20, 144, 145,9,13,19,
    33,34,35,36,37,38,39,40,44,45,46,    //35
// F1-F12
    121,122,123,112,113,114,115,116,117,118,119,120, //47
// symbols
    186,186,222, 222,188,188,190,190,191,191,189,189, 187,187,192,192,219,219,221,221,220,220, //69
// a-z
    65,66,67,68,69,70,71,72,73,74, 75,76,77,78,79,80,81,82,83,84, 85,86,87,88,89,90, //95
// 0-10
    48,49,50,51, 52,53,54,55,56,57 //105
    );
  ssKeys:TssKeys=(
// numpad
    'NUM0','NUM1','NUM2','NUM3','NUM4','NUM5','NUM6','NUM7','NUM8','NUM9','NUM/','NUM*','NUM-','NUM+','NUM.',
// control
    'BACKSPACE','SPACE','ESC','CAPSLOCK','NUMLOCK','SCROLLLOCK','TAB','ENTER','PAUSE',
    'PAGEUP','PAGEDOWN','END','HOME','LEFT','UP','RIGHT','DOWN','PRINTSCREEN','INS','DEL',
// F1-F12
    'F10','F11','F12','F1','F2','F3','F4','F5','F6','F7','F8','F9',
// symbols
    ':',';','''','"',',','<','.','>','/','?','-','_','=','+','`','~','[','{',']','}','\','|',
// a-z
    'A','B','C','D','E','F','G','H','I','J','K','L','M','N','O','P','Q','R','S','T','U','V','W','X','Y','Z',
// 0-10
    '0','1','2','3','4','5','6','7','8,','9'
    );

function OpenPlugin(OpenFrom:OPEN; s1:PChar):THandle stdcall export;

  function InStrKey(var sWhere:string; sWhat:string; keysa:integer):boolean;
  var
    i1:integer;
  begin
    i1:=Pos(sWhat,sWhere);
    if i1>0 then begin
      delete(sWhere,i1,length(sWhat));
      Keybd_Event(keysa,0,0,0);
      result:=true;
     end
    else begin
      result:=false;
     end;
  end;

  Procedure KeyUps(b1:boolean; keysa:integer);
  begin
    if b1 then Keybd_Event(keysa,0,KEYEVENTF_KEYUP,0);
  end;

var
  i1,i2,i3:integer;
  s2,s3,s4:string;
  bCtrl,bAlt,bShift:boolean;
begin
  if OpenFrom=OPEN_PLUGINSMENU then begin
    message(0,'Content',[integer(MHead),integer(MTitle),integer(MOk)],1);
   end
  else begin
    if (s1<> nil) then begin
      s3:=trim(StrPas(StrUpper(s1)))+' ';
      i3:=pos(' ',s3);
      while i3<>0 do begin
        s4:=copy(s3,1,i3-1);
        s2:=copy(s3,i3,length(s3));
        s3:=trim(s2)+' ';
        try
          i1:=StrToInt(s4);
          i2:=0;
          if (i1 >1000) then begin
            i2:=KEYEVENTF_KEYUP;
            i1:=i1-1000;
           end;
          Keybd_Event(i1,0,i2,0);
        except
          on E:EConvertError do begin
            if pos('SLEEP',s4)<>0 then begin
              sleep(100);
             end
            else begin
              s2:=' '+s4+' ';
              bAlt:=InStrKey(s2,'ALT',18);
              bCtrl:=InStrKey(s2,'CTRL',17);
              bShift:=InStrKey(s2,'SHIFT',16);

              for i1:=1 to iKeys do begin
                if InStrKey(s2,ssKeys[i1],bsKeys[i1]) then begin
                  KeyUps(true,bsKeys[i1]);
                 end;
               end;

              KeyUps(bShift,16);
              KeyUps(bCtrl,17);
              KeyUps(bAlt,18);
             end;
           end;
         end;
        i3:=pos(' ',s3);
        if i3=1 then break;
       end;
     end;
   end;
  Result:=INVALID_HANDLE_VALUE;
end;

procedure GetPluginInfo(var Info:TPluginInfo); stdcall export;
begin
  with Info do begin
    StructSize:=SizeOf(Info);
    Flags:=PF_EDITOR;
    DiskMEnuStringsNumber:=0;

    ssPlugins[0]:=GetMsg(MTitle);
    PluginMenuStrings:=@ssPlugins;
    PluginMenuStringsNumber:=1;
    PluginConfigStringsNumber:=0;

    CommandPrefix:=sPrefix;
   end;
end;

exports
  OpenPlugin,
  GetPluginInfo;

begin
end.
